var prev = null;
var current = 0;
var width = 0;
var heigth = 0;
var getDimensions = false
var tdpage1;
var croppingOnly = %s;

function drawImages (left, top, cnv, images) {
  var width = images[0].width;
  var height = images[0].height;
  if (images.length == 3) {
    width += Math.max(images[1].width, images[2].width);
    height += images[1].height + images[2].height;
  } else if (images.length == 2) {
    width += images[1].width;
    height += images[1].height;
  }
    
  cnv.width = width;
  cnv.height = height;
  cnv.style.left = left + 20;
  cnv.style.top = top;
  
  var ctx = cnv.getContext('2d');
  ctx.drawImage(images[0], 0, 0);
  
  if (images.length > 1) {
	  ctx.drawImage(images[1],  images[0].width, 0);
  }
  if (images.length > 2) {
    ctx.drawImage(images[2], images[0].width, images[1].height);
  }
}

function showImage (obj, n) {
  var imagesOriginalPath = '%s'		// e.g., 'file:///C:/Users/ralph/Documents/PeterScharf/SanskritLibrary/ImageConverter/reducedOriginal/';     // e.g. E:/JPEGImages/
  var imagesCroppedPath = '%s';		// e.g.,'file:///C:/Users/ralph/Documents/PeterScharf/SanskritLibrary/ImageConverter/reducedCropped/';     // e.g. F:/
  var mssDirectory = '%s';					// e.g., 'UPenn/mscoll390_item349_wk1/';
  var subDirectory = '%s';
  var fields;
  var cropName;
  var img = im[n].img;
  var full = document.getElementById('page');
  var list = document.getElementById('list');
  var src;
  var blankImage = false;
  
  if (img == '/%s') {     // was there no image?
  	src = imagesOriginalPath + img + '.jpg';     // if so, then use standard page announcing no image
  	blankImage = true;
  } else {
  	if (croppingOnly) {
	  	src = imagesCroppedPath + mssDirectory + img + '.jpg';
	 } else {
	  	src = imagesOriginalPath + mssDirectory + img + '.jpg';
	 }
  }

  current = n;
  var images = new Array();
  images.push(new Image());
  if (blankImage) {
	  images[0].onload = function () {
        drawImages(list.offsetWidth, obj.offsetTop, full, images)      
  	  }
	  images[0].src = src;     
  } else if (croppingOnly) {
	  images[0].onload = function () {
		if (im[n].numPages == 2) {
			images.push(new Image());
			images[1].onload = function () {
			  	drawImages(list.offsetWidth, obj.offsetTop, full, images);		// draw crop1 and crop2
		  	}
		  	images[1].src = imagesCroppedPath + mssDirectory + subDirectory + img + '_crop2.jpg';
		 } else {		// just draw crop 1
			drawImages(list.offsetWidth, obj.offsetTop, full, images)      
		 }
	  }
	  images[0].src = imagesCroppedPath + mssDirectory + subDirectory + img + '_crop1.jpg';
  } else {
	  images[0].onload = function () {
		images.push(new Image());
		images[1].onload = function () {
		  if (im[n].numPages == 2) {   // draw crop of second page
			images.push(new Image());
			images[2].onload = function () {
			  drawImages(list.offsetWidth, obj.offsetTop, full, images);
			}
			
			images[2].src = imagesCroppedPath + mssDirectory + subDirectory + img + '_crop2.jpg';
		  } else {
			drawImages(list.offsetWidth, obj.offsetTop, full, images)      
		  }
		}
		   
		images[1].src = imagesCroppedPath + mssDirectory + subDirectory + img + '_crop1.jpg';
	  }

	  images[0].src = src;     
  }
  
  if (prev != null) {
    prev.style.backgroundColor = '#ffffff';
    window.scrollTo(0, obj.offsetTop);
  }
  obj.style.backgroundColor = '#ff0000';
  prev = obj;
}


function handlekey (evt) {
	var el;
  if (evt.keyCode == 44) {
  	if (current != 0) {
  		current--;
  		el = document.getElementById("td" + current);
  		showImage(el, current);
  	}
  } else if (evt.keyCode == 46) {
  	if (current != im.length-1) {
  		current++;
  		el = document.getElementById("td" + current);
  		showImage(el, current);
  	}
  }
}

function init () {
	var bd = document.getElementById('bd');
	bd.onkeypress = handlekey;
  el = document.getElementById("td0");
  showImage(el, 0);
}