package folio;

import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import org.sanskritlibrary.Regex;
import org.sanskritlibrary.SAXParser;
import org.sanskritlibrary.SAXParserHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class Errors implements SAXParserHandler
{
    public static Hashtable<String, Boolean> missingAnnotationDirectories = new Hashtable<String, Boolean>();
    public static Hashtable<String, Boolean> emptyAnnotationDirectories = new Hashtable<String, Boolean>();
    public static Hashtable<String, Boolean> missingAnnotations = new Hashtable<String, Boolean>();
    public static ArrayList<Regex> patterns = new ArrayList<Regex>();
    private Locator locator;
    private String filename;
    private String shortname;
    private SAXParser saxParser;
    private StringBuilder buffer = new StringBuilder();
    private boolean collectText = false;

    public Errors () {
        saxParser = new SAXParser(this);
    }

    public void parse(String filename) throws Exception {
        this.filename = filename;
        buffer.setLength(0);
        shortname = new File(filename).getName();
        shortname = shortname.substring(0, shortname.indexOf("."));
        try {
            saxParser.parse(filename);
        } catch (Exception ex) {

        }
    }

    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        String msg = String.format("%s:%d.%d %s\n", filename, locator.getLineNumber(), locator.getColumnNumber(), exception.getMessage());
        Main.writeError(msg);
        throw new SAXException("Boom!");
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {

    }

    public void endDocument() throws SAXException {
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        if (qName.equals("missingAnnotationDirectory")) {
            collectText = true;
        } else if (qName.equals("emptyAnnotationDirectory")) {
            emptyAnnotationDirectories.put(atts.getValue("name"), Boolean.TRUE);
        } else if (qName.equals("missingAnnotation")) {
            collectText = true;
        }else if (qName.equals("pattern")) {
            String re = atts.getValue("re");
            patterns.add(new Regex("", re));
        } else if (qName.equals("")) {

        }
    }


    public void endElement(String uri, String localName, String qName) throws SAXException {
        if (qName.equals("missingAnnotationDirectory")) {
            missingAnnotationDirectories.put(buffer.toString().trim(), true);
            collectText = false;
            buffer.setLength(0);
        } else if (qName.equals("missingAnnotation")) {
            missingAnnotations.put(buffer.toString().trim(), true);
            collectText = false;
            buffer.setLength(0);
        }
    }


    public void characters(char[] ch, int start, int length) throws SAXException {
        if (collectText) {
            buffer.append(new String(ch, start, length));
        }
    }
}
