package folio;

import org.sanskritlibrary.TextFormatter;

public class InsertionPoint {
    public static int debugCount = 0;
    private String id;               // xml:id of facsimile element
    private int startLine = -1;      // line of facsimile start element
    private int endLine = -1;        // line of facsimile end element
    private String from;             // attribute of locus
    private String to;               // attribute of locus

    public InsertionPoint () {
        debugCount++;
        if (debugCount == 377) {
            debugCount = 377;
        }
    }
    
    public void setID(String id) {
        this.id = id;
    }

    public String getID() {
        return this.id;
    }

    public void setStartLine(int startLine) {
        this.startLine = startLine;
    }

    public int getStartLine() {
        return this.startLine;
    }

    public void setEndLine(int endLine) {
        this.endLine = endLine;
    }
    
    public int getEndLine() {
        return this.endLine;
    }

    public void setTo(String to) {
        this.to = TextFormatter.normalizeID(to);
    }

    public String getTo() {
        return this.to;
    }

    public void setFrom(String from) {
        this.from = TextFormatter.normalizeID(from);
    }

    public String getFrom() {
        return this.from;
    }

    @Override
    public String toString () {
        return String.format("%s: locus=%s to %s (lines %d-%d)", id, from, to, startLine, endLine);
    }
}
