package folio;

import java.util.ArrayList;

public class SurfaceInfo {
    static String indent = "";
    static private int idNumber = 1;
    public GraphicInfo graphic;
    public ArrayList<ZoneInfo> zones = new ArrayList<ZoneInfo>();
    public int missingZones = 0;
    public int extraZones = 0;
    public String addedBy = null;
    public String facsGrp;

    

    public static SurfaceInfo blankSurface(String url) {
        SurfaceInfo si = new SurfaceInfo();
        si.graphic = new GraphicInfo();
        si.graphic.desc = "";
        si.graphic.setID(Integer.toString(idNumber));
        si.graphic.url = "noImage.jpg";
        si.zones = new ArrayList();
        ZoneInfo zi = new ZoneInfo();
        zi.graphic = new GraphicInfo();
        zi.graphic.desc = "";
        zi.graphic.setID(Integer.toString(idNumber));
        zi.graphic.url = url;
        si.zones.add(zi);
        idNumber++;
        return si;
    }

    @Override
    public String toString () {
        StringBuilder sb = new StringBuilder();

        sb.append(String.format("%s<surface>\n", indent));
        graphic.indent = indent + "  ";
        String delim = "";
        sb.append(graphic.toString());
        sb.append("\n");
        for (ZoneInfo zi : zones) {
            zi.indent = graphic.indent;         // since graphic and zone elements are siblings
            sb.append(delim);
            sb.append(zi.toString());
            delim = "\n";
        }
        sb.append(String.format("\n%s</surface>", indent));

        return sb.toString();
    }

    public void fixup () {
        for (int i=0; i<missingZones; i++) {
            ZoneInfo zi = new ZoneInfo();
            zi.graphic = new GraphicInfo();
            zi.graphic.setID("?");
            zi.graphic.url = "?";
            zones.add(zi);
        }

        for (int i=0; i<extraZones; i++) {
            int last = zones.size() - 1;
            if (last >= 0) {
                zones.remove(last);
            }
        }
    }

    public void createIDFromZoneIDs (String facsid) {
        StringBuilder sb = new StringBuilder();
        for (ZoneInfo zi : zones) {
            sb.append(zi.graphic.getID());
        }
        graphic.setID(sb.toString());
        if (facsid != null) {
            graphic.desc = facsid;
        }
    }
}

