package folio;

class ZoneInfo {
    public static String indent = "";
    public int ulx;         // attribute
    public int uly;         // attribute
    public int lrx;         // attribute
    public int lry;         // attribute
    public GraphicInfo graphic;
    public boolean accountedFor = false;

    @Override
    public String toString () {
        StringBuilder sb = new StringBuilder();
        sb.append(String.format("%s<zone ulx='%d' uly='%d' lrx='%d' lry='%d'>\n",
                indent, ulx, uly, lrx, lry));
        graphic.indent = indent + "  ";
        sb.append(graphic.toString());
        sb.append("\n");
        sb.append(String.format("%s</zone>", indent));
        return sb.toString();
    }

    public void mapDescToId() {
        if (!graphic.desc.contains(",")) {
            graphic.setID(String.format("f%s", graphic.desc.substring(3)));
        }
    }

    public boolean isEmpty() {
        return ulx==0 && uly==0 && lrx==0 && lry==0;
    }
}
